import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Products.ATContentTypes.content.newsitem import ATNewsItem
from Products.Five.site.localsite import enableLocalSiteHook
from Products.ThemeCentre.tests.ThemeCentreTestCase import ThemeCentreTestCase
from eea.rdfrepository.rdfrepository import RDFRepository
from eea.themecentre.interfaces import IThemeTagging, IThemeTaggable
from eea.themecentre.interfaces import IThemeCentreSchema
from eea.rdfrepository.interfaces import IRDFRepository
from zope.app.annotation.interfaces import IAnnotations
from zope.app.annotation.attribute import AttributeAnnotations
from zope.app.component.hooks import setSite
from zope.component import provideAdapter, provideUtility
from zope.interface import classImplements, alsoProvides
from os.path import dirname, join
from Products.ThemeCentre import tests
from Products.ThemeCentre.mergedtheme import ThemeTaggableMerged
from Products.PloneTestCase.PloneTestCase import default_user
from Products.PloneTestCase.PloneTestCase import default_password


class TestMultilingual(ThemeCentreTestCase):

    def afterSetUp(self):
        enableLocalSiteHook(self.portal)
        setSite(self.portal)

        provideAdapter(ThemeTaggableMerged)
        provideAdapter(AttributeAnnotations, provides=IAnnotations,
                adapts=[IThemeTaggable])
        provideUtility(RDFRepository())
        classImplements(ATNewsItem, IThemeTaggable)
        self.setRoles('Manager')
        rdf_file_sv = join(dirname(tests.__file__), 'sample-sv.rdf')
        rdf_file_en = join(dirname(tests.__file__), 'sample-en.rdf')

        wftool = self.portal.portal_workflow
        # create a swedish themecentre, an english feed folder and
        # a swedish feed
        self.portal.invokeFactory('Folder', id='svthemecentre')
        obj = self.portal.svthemecentre
        # turn the folder into a themecentre by calling the promote view
        # and setting a theme tag
        obj.unrestrictedTraverse('@@promote2ThemeCentre')()
        IThemeCentreSchema(obj).tags = 'climate'
        obj.setLanguage('sv')
        obj.intro.setLanguage('sv')
        wftool.doActionFor(obj, 'publish')
        obj.reindexObject()

        self.portal.invokeFactory('Folder', id='feedfolder')
        self.portal.feedfolder.setLanguage('en')
        alsoProvides(self.portal.feedfolder, IRDFRepository)
        self.portal.feedfolder.reindexObject()

        self.portal.feedfolder.invokeFactory('RSSFeedRecipe', id='svfeed')
        self.portal.feedfolder.svfeed.setLanguage('sv')
        self.portal.feedfolder.svfeed.setFeedURL(rdf_file_sv)
        self.portal.feedfolder.svfeed.setEntriesSize(100)
        IThemeTagging(self.portal.feedfolder.svfeed).tags = ['climate']
        wftool.doActionFor(self.portal.feedfolder.svfeed, 'publish')
        self.portal.feedfolder.svfeed.reindexObject()

        self.portal.feedfolder.invokeFactory('RSSFeedRecipe', id='enfeed')
        self.portal.feedfolder.enfeed.setLanguage('en')
        self.portal.feedfolder.enfeed.setFeedURL(rdf_file_en)
        self.portal.feedfolder.enfeed.setEntriesSize(100)
        IThemeTagging(self.portal.feedfolder.enfeed).tags = ['climate']
        wftool.doActionFor(self.portal.feedfolder.enfeed, 'publish')
        self.portal.feedfolder.enfeed.reindexObject()

        self.portal.portal_languages.addSupportedLanguage('sv')
        self.basic_auth = '%s:%s' % (default_user, default_password)


def test_suite():
    from unittest import TestSuite
    from Testing.ZopeTestCase import FunctionalDocFileSuite

    suite = TestSuite()
    suite.addTest(FunctionalDocFileSuite('portlets.txt',
        test_class = TestMultilingual,
        package = 'Products.ThemeCentre.tests'))

    return suite
